/*
 * suart_bus.c
 *
 * Created: 13.01.2012 09:26:11
 *  Author: Portisch
 */ 



#include "suart.h"
#include "../myConfig.h"
#include "suart_bus.h"

uint8_t suart_state			= 0x00;
uint8_t expected_data_len	= 0x00;
uint8_t receive_data_len	= 0x00;


void _send_raw_bytes(uint8_t *data, uint8_t len)
{
	uint8_t i;
	
	for (i=0; i<len;i++)
	{
		suart_putc(data[i]);
	}
}

uint8_t Calc_CRC(uint8_t *data, uint8_t len)
{
	uint8_t i;
	uint8_t c = 0x55;
	
	for (i=0; i<len;i++)
	{
		c ^= data[i];
	}
	
	return c;		
}

void init_suart(void)
{
	suart_init();
}

int CRC_Valid(uint8_t *data, uint8_t len, uint8_t CRC)
{
	uint8_t i;
	uint8_t c = 0x55;
	
	for (i=0; i<len;i++)
	{
		c ^= data[i];
	}
	
	if (CRC == c)
	{
		return TRUE;
	} 
	else
	{
		return FALSE;
	}		
}

/*
void SendCommand(uint8_t receiver, uint8_t command)
{
	uint8_t tmp_data[4];

	tmp_data[0] = BUS_SYNC_BYTE_1;
	tmp_data[1] = BUS_SYNC_BYTE_2;
	tmp_data[2] = receiver;
	tmp_data[3] = sizeof(command);
	tmp_data[4] = command;
	tmp_data[5] = Calc_CRC(&tmp_data[4], sizeof(command));
	
	_send_raw_bytes(&tmp_data[0], sizeof(tmp_data));	
}


void SendByte(uint8_t receiver, uint8_t command, uint8_t data)
{
	uint8_t tmp_data[7];

	tmp_data[0] = BUS_SYNC_BYTE_1;
	tmp_data[1] = BUS_SYNC_BYTE_2;
	tmp_data[2] = receiver;
	tmp_data[3] = sizeof(command) + sizeof(data);
	tmp_data[3] = command;
	tmp_data[4] = data;
	tmp_data[5] = Calc_CRC(&tmp_data[4], sizeof(command) + sizeof(data));
	
	_send_raw_bytes(&tmp_data[0], sizeof(tmp_data));
}
*/

void SendBytes(uint8_t receiver, uint8_t command, uint8_t *data, uint8_t len)
{
	uint8_t tmp_data[255];
	uint8_t i;

	tmp_data[0] = BUS_SYNC_BYTE_1;
	tmp_data[1] = BUS_SYNC_BYTE_2;
	tmp_data[2] = receiver;
	tmp_data[3] = len + sizeof(command) + sizeof(uint8_t);
	tmp_data[4] = command;
	
	for (i=0; i<len;i++)
	{
		tmp_data[5+i] = data[i];	
	}
	
	tmp_data[5+len] = Calc_CRC(&tmp_data[4], len + sizeof(command));
	
	_send_raw_bytes(&tmp_data[0], len + 5 + sizeof(uint8_t));
}

void SendAKN(uint8_t receiver)
{
	SendBytes(receiver, CMD_AKN, 0, 0);
}

void SendNAKN(uint8_t receiver)
{
	SendBytes(receiver, CMD_NAKN, 0, 0);
}
