/*
 * suart_bus.h
 *
 * Created: 13.01.2012 09:26:30
 *  Author: Portisch
 */ 


#ifndef SUART_BUS_H_
#define SUART_BUS_H_

#include <stdint.h>

#define BUS_SYNC_BYTE_1					0x00			// first sync byte
#define BUS_SYNC_BYTE_2					0x55			// first sync byte

#define CMD_WRITE_IRMP_CODES			0x00
#define CMD_READ_IRMP_CODES				0x01
#define CMD_IRMP_DECODED_CMD			0x10
#define CMD_AKN							0xFE
#define CMD_NAKN						0xFF

extern uint8_t suart_state;
extern uint8_t expected_data_len;
extern uint8_t receive_data_len;


extern void init_suart(void);
extern void SendCommand(uint8_t receiver, uint8_t command);
extern void SendByte(uint8_t receiver, uint8_t command, uint8_t data);
extern void SendBytes(uint8_t receiver, uint8_t command, uint8_t *data, uint8_t len);
extern void SendAKN(uint8_t receiver);
extern void SendNAKN(uint8_t receiver);
extern int CRC_Valid(uint8_t *data, uint8_t len, uint8_t CRC);


#endif /* SUART_BUS_H_ */