/*
 * myConfig.h
 *
 * Created: 11.01.2012 12:17:40
 *  Author: Portisch
 */ 


#ifndef MYCONFIG_H_
#define MYCONFIG_H_

#define BUS_MASTER

#ifndef BUS_MASTER
#include "irmp.h"
#endif

#define TRUE                                    1
#define FALSE                                   0

// UART Baudrate
#define BAUD 9600

// BUS system commands
#define BUS_MASTER_NODE_ID				0x00			// define bus master node id, default 0x00
#define BUS_SLAVE_NODE_ID				0x01			// define bus slave node id 1..254
#define BUS_SLAVE_GLOBAL_ID				0xFF			// define bus slave gloabl id, default 0xFF

#ifndef	struct IRMP_DATA
typedef struct
{
  uint8_t               protocol;                                               // protocol, i.e. NEC_PROTOCOL
  uint16_t              address;                                                // address
  uint16_t              command;                                                // command
  uint8_t               flags;                                                  // flags, e.g. repetition
} IRMP_DATA;
#endif

typedef struct
{
  uint8_t			bus_command;						// bus command
  IRMP_DATA			command_IR_data; 
} BUS_IRMP_DATA;

// global bus buffer
BUS_IRMP_DATA busirmpcodes[32];

uint8_t bus_buffer[252];

/*
// BUS system command (in bytes)
1. sync byte 1
2. sync byte 2
3. receiver node id
4. command byte
5. data len (crc xor byte incloded)
6. data byte
n. data byte
n+1. crc xor byte

crc xor:
0x55 xor (data byte 0) xor (data byte n)

// RS232 system command
1. sync byte 1
2. sync byte 2
3. data len
4. command byte
5. data byte
n. data byte



*/

#endif /* MYCONFIG_H_ */